# /* Bakery Lamport's algorithm for mutual exclusion */
# /* David Dedic, december 2002 */

pa_read_process "bakery.dat"

# You can choose: with or without request signals
# ACTL formulae for model checking are WITH request signals

set type ""
set actions "request1 request2 enter1 exit1 enter2 exit2"

#set type "_brez_request"
#set actions "enter1 exit1 enter2 exit2"

pa_encode_process "EMPTY$type"
pa_encode_process "Y1 Y2 YPLUS Y1PLUS Y2PLUS"
pa_encode_process "N1 N2 C1 C2 NPLUS N1PLUS N2PLUS"
pa_encode_process "P1STEP P2STEP P1BENARI P2BENARI P1BAKERY P2BAKERY"
pa_encode_process "STEP_weak$type STEP2_weak$type"
pa_encode_process "STEP_test$type STEP2_test$type"
pa_encode_process "BAKERY_weak$type BAKERY2_weak$type"
pa_encode_process "BAKERY_test$type BAKERY2_test$type"
pa_encode_process "BENARI_weak$type BENARI2_weak$type BENARI_test$type"

outline ""
outline "########################################################"
outline ""
outline "ALGORITEM STEP S PROCESOM YPLUS"

versis_compose 1 STEP \
   "EMPTY$type P1STEP P2STEP Y1 Y2 YPLUS" \
   $actions

outline ""
versis_testing_equivalence 1 STEP 0 STEP_test$type
versis_weak_equivalence 1 STEP 0 STEP_weak$type

outline ""
mc_check_actl 1 STEP "bakery.actl"

outline ""
outline "########################################################"
outline ""
outline "ALGORITEM STEP S PROCESOMA Y1PLUS IN Y2PLUS"

versis_compose 1 STEP2 \
   "EMPTY$type P1STEP P2STEP Y1 Y2 Y1PLUS Y2PLUS" \
   $actions

outline ""
versis_testing_equivalence 1 STEP2 0 STEP2_test$type
versis_weak_equivalence 1 STEP2 0 STEP2_weak$type

outline ""
mc_check_actl 1 STEP2 "bakery.actl"

outline ""
outline "########################################################"
outline ""
outline "ALGORITEM BEN-ARI S PROCESOM NPLUS"

versis_compose 1 BENARI \
   "EMPTY$type P1BENARI P2BENARI N1 N2 NPLUS" \
   $actions

outline ""
versis_testing_equivalence 1 BENARI 0 BENARI_test$type
versis_weak_equivalence 1 BENARI 0 BENARI_weak$type

outline ""
mc_check_actl 1 BENARI "bakery.actl"

outline ""
outline "########################################################"
outline ""
outline "ALGORITEM BEN-ARI S PROCESOMA N1PLUS IN N2PLUS"

versis_compose 1 BENARI2 \
   "EMPTY$type P1BENARI P2BENARI N1 N2 N1PLUS N2PLUS" \
   $actions

outline ""
versis_testing_equivalence 1 BENARI2 0 BENARI_test$type
versis_weak_equivalence 1 BENARI2 0 BENARI2_weak$type

outline ""
mc_check_actl 1 BENARI2 "bakery.actl"

outline ""
outline "########################################################"
outline ""
outline "LAMPORTOV BAKERY ALGORITEM S PROCESOM NPLUS"

versis_compose 1 BAKERY \
   "EMPTY$type P1BAKERY P2BAKERY C1 C2 N1 N2 NPLUS" \
   $actions

outline ""
versis_testing_equivalence 1 BAKERY 0 BAKERY_test$type
versis_weak_equivalence 1 BAKERY 0 BAKERY_weak$type

outline ""
mc_check_actl 1 BAKERY "bakery.actl"

outline ""
outline "########################################################"
outline ""
outline "LAMPORTOV BAKERY ALGORITEM S PROCESOMA N1PLUS IN N2PLUS"

versis_compose 1 BAKERY2 \
   "EMPTY$type P1BAKERY P2BAKERY C1 C2 N1 N2 N1PLUS N2PLUS" \
   $actions

outline ""
versis_testing_equivalence 1 BAKERY2 0 BAKERY2_test$type
versis_weak_equivalence 1 BAKERY2 0 BAKERY2_weak$type

outline ""
mc_check_actl 1 BAKERY2 "bakery.actl"

outline ""
outline "########################################################"
outline ""
outline "PRIMERJAVA OBEH VARIANT ZA ALGORITEM STEP"
versis_trace_equivalence 1 STEP 1 STEP2
versis_testing_equivalence 1 STEP 1 STEP2

outline ""
outline "PRIMERJAVA OBEH VARIANT ZA ALGORITEM BEN-ARI"
versis_trace_equivalence 1 BENARI 1 BENARI2
versis_testing_equivalence 1 BENARI 1 BENARI2

outline ""
outline "PRIMERJAVA OBEH VARIANT ZA LAMPORTOV BAKERY ALGORITEM"
versis_trace_equivalence 1 BAKERY 1 BAKERY2
versis_testing_equivalence 1 BAKERY 1 BAKERY2

outline ""
outline "PRIMERJAVA RAZLICNIH ALGORITMOV"
versis_trace_equivalence 1 STEP 1 BENARI
versis_trace_equivalence 1 STEP 1 BAKERY
versis_trace_equivalence 1 BENARI 1 BAKERY

outline ""
outline "PRIMERJAVA RAZLICNIH ALGORITMOV"
versis_testing_equivalence 1 STEP 1 BENARI
versis_testing_equivalence 1 STEP 1 BAKERY
versis_testing_equivalence 1 BENARI 1 BAKERY
