# /* Robert Meolic, 13. 9. 2002 */
# /* Clanek za Midem */

set model "rejective"

pa_read_sort "sortDME-smv-2all.dat"

pa_read_process "fork1abc.dat"
pa_read_process "or2abc.dat"
pa_read_process "and2abc.dat"
pa_read_process "c2abc.dat"
pa_read_process "me2abcd.dat"
pa_read_process "rsqb2abcd.dat"

pa_encode_process "fork1abc0-$model"
pa_encode_process "fork1abc1-$model"
pa_encode_process "and2abc00-$model"
pa_encode_process "and2abc01-$model"
pa_encode_process "and2abc10-$model"
pa_encode_process "and2abc11-$model"
pa_encode_process "or2abc00-$model"
pa_encode_process "or2abc01-$model"
pa_encode_process "or2abc10-$model"
pa_encode_process "or2abc11-$model"
pa_encode_process "c2abc00-$model"
pa_encode_process "me2abcd00-$model"
pa_encode_process "rsqb2abcd0001-$model"
pa_encode_process "rsqb2abcd0010-$model"

pa_copy_process me2abcd00-$model MEurlrab NULL "a b c d" "ur lr a b"
pa_copy_process and2abc01-$model ANDaoc NULL "a b c" "a o c"
pa_copy_process and2abc10-$model ANDpbd NULL "a b c" "p b d"
pa_copy_process c2abc00-$model Ccie NULL "a b c" "c i e"
pa_copy_process c2abc00-$model Cdif NULL "a b c" "d i f"
pa_copy_process or2abc00-$model ORcdg NULL "a b c" "c d g"
pa_copy_process c2abc00-$model Cgjh NULL "a b c" "g j h"
pa_copy_process and2abc01-$model ANDhji NULL "a b c" "h j i"
pa_copy_process or2abc00-$model ORlraj NULL "a b c" "l ra j"
pa_copy_process and2abc01-$model ANDghk NULL "a b c" "g h k"
pa_copy_process fork1abc0-$model FORKqola NULL "a b c" "q o la"
pa_copy_process fork1abc0-$model FORKrpua NULL "a b c" "r p ua"

pa_copy_process rsqb2abcd0001-$model RSfemn01 NULL "a b c d" "f e m n"
pa_copy_process and2abc00-$model ANDemr0 NULL "a b c" "e m r"
pa_copy_process and2abc00-$model ANDkml0 NULL "a b c" "k m l"
pa_copy_process and2abc01-$model ANDfnq1 NULL "a b c" "f n q"
pa_copy_process and2abc10-$model ANDnkrr1 NULL "a b c" "n k rr"

pa_copy_process rsqb2abcd0010-$model RSfemn10 NULL "a b c d" "f e m n"
pa_copy_process and2abc01-$model ANDemr1 NULL "a b c" "e m r"
pa_copy_process and2abc01-$model ANDkml1 NULL "a b c" "k m l"
pa_copy_process and2abc00-$model ANDfnq0 NULL "a b c" "f n q"
pa_copy_process and2abc00-$model ANDnkrr0 NULL "a b c" "n k rr"

# ###############################################
# Create DME
# ###############################################

versis_compose 7 DME-false \
  "MEurlrab ANDaoc ANDpbd Ccie Cdif ORcdg Cgjh ANDhji ORlraj ANDghk ANDkml0 RSfemn01 ANDfnq1 ANDemr0 ANDnkrr1 FORKqola FORKrpua" \
  "ur ua lr la rr ra"

versis_compose 7 DME-true \
  "MEurlrab ANDaoc ANDpbd Ccie Cdif ORcdg Cgjh ANDhji ORlraj ANDghk ANDkml1 RSfemn10 ANDfnq0 ANDemr1 ANDnkrr0 FORKqola FORKrpua" \
  "ur ua lr la rr ra"

# ###############################################
# Check for hazards
# ###############################################

pa_copy_process DME-false DME-false-ua NULL "la rr" "tau tau"
pa_copy_process DME-false DME-false-la NULL "ua rr" "tau tau"
pa_copy_process DME-false DME-false-rr NULL "ua la" "tau tau"

pa_copy_process DME-true DME-true-ua NULL "la rr" "tau tau"
pa_copy_process DME-true DME-true-la NULL "ua rr" "tau tau"
pa_copy_process DME-true DME-true-rr NULL "ua la" "tau tau"

versis_trace_minimization 0 DME-false-ua
versis_trace_minimization 0 DME-false-la
versis_trace_minimization 0 DME-false-rr

versis_trace_minimization 0 DME-true-ua
versis_trace_minimization 0 DME-true-la
versis_trace_minimization 0 DME-true-rr

# -----------------------------------------------

mc_check_actl 0 TRACE_DME-false-ua "dme-cell.actl"
mc_check_actl 0 TRACE_DME-false-la "dme-cell.actl"
mc_check_actl 0 TRACE_DME-false-rr "dme-cell.actl"
mc_check_actl 0 TRACE_DME-true-ua "dme-cell.actl"
mc_check_actl 0 TRACE_DME-true-la "dme-cell.actl"
mc_check_actl 0 TRACE_DME-true-rr "dme-cell.actl"


# ###############################################
# Compose DMEs and check properties
# ###############################################

pa_copy_process DME-false DME1 NULL "ur ua lr la rr ra" "ur1 ua1 r12 a21 r21 a12"

pa_copy_process DME-true DME2 NULL "ur ua lr la rr ra" "ur2 ua2 r21 a12 r12 a21"

# ###############################################

versis_compose 7 DME \
  "DME1 DME2" \
  "ur1 ua1 ur2 ua2"

mc_check_actl 0 DME "dme2.actl"
