# /* Robert Meolic, 29. 11. 2002 */
# /* Clanek za Midem */

set model "rejective"

pa_read_sort "sortDME-smv.dat"

pa_read_process "fork1abc.dat"
pa_read_process "or2abc.dat"
pa_read_process "and2abc.dat"
pa_read_process "c2abc.dat"
pa_read_process "me2abcd.dat"
pa_read_process "rsqb2abcd.dat"

pa_encode_process "fork1abc0-$model"
pa_encode_process "fork1abc1-$model"
pa_encode_process "and2abc00-$model"
pa_encode_process "and2abc01-$model"
pa_encode_process "and2abc10-$model"
pa_encode_process "and2abc11-$model"
pa_encode_process "or2abc00-$model"
pa_encode_process "or2abc01-$model"
pa_encode_process "or2abc10-$model"
pa_encode_process "or2abc11-$model"
pa_encode_process "c2abc00-$model"
pa_encode_process "me2abcd00-$model"
pa_encode_process "rsqb2abcd0001-$model"
pa_encode_process "rsqb2abcd0010-$model"

pa_copy_process me2abcd00-$model MEurlrab NULL "a b c d" "ur lr a b"
pa_copy_process and2abc01-$model ANDaoc NULL "a b c" "a o c"
pa_copy_process and2abc10-$model ANDpbd NULL "a b c" "p b d"
pa_copy_process c2abc00-$model Ccie NULL "a b c" "c i e"
pa_copy_process c2abc00-$model Cdif NULL "a b c" "d i f"
pa_copy_process or2abc00-$model ORcdg NULL "a b c" "c d g"
pa_copy_process c2abc00-$model Cgjh NULL "a b c" "g j h"
pa_copy_process and2abc01-$model ANDhji NULL "a b c" "h j i"
pa_copy_process or2abc00-$model ORlraj NULL "a b c" "l ra j"
pa_copy_process and2abc01-$model ANDghk NULL "a b c" "g h k"
pa_copy_process fork1abc0-$model FORKqola NULL "a b c" "q o la"
pa_copy_process fork1abc0-$model FORKrpua NULL "a b c" "r p ua"

pa_copy_process rsqb2abcd0001-$model RSfemn01 NULL "a b c d" "f e m n"
pa_copy_process and2abc00-$model ANDemr0 NULL "a b c" "e m r"
pa_copy_process and2abc00-$model ANDkml0 NULL "a b c" "k m l"
pa_copy_process and2abc01-$model ANDfnq1 NULL "a b c" "f n q"
pa_copy_process and2abc10-$model ANDnkrr1 NULL "a b c" "n k rr"

pa_copy_process rsqb2abcd0010-$model RSfemn10 NULL "a b c d" "f e m n"
pa_copy_process and2abc01-$model ANDemr1 NULL "a b c" "e m r"
pa_copy_process and2abc01-$model ANDkml1 NULL "a b c" "k m l"
pa_copy_process and2abc00-$model ANDfnq0 NULL "a b c" "f n q"
pa_copy_process and2abc00-$model ANDnkrr0 NULL "a b c" "n k rr"

# -----------------------------------------------

outline ""
outline " ==========================="
outline " COMPOSITION OF PROCESSES"
outline " ==========================="
outline ""

versis_compose 7 DME-false \
  "MEurlrab ANDaoc ANDpbd Ccie Cdif ORcdg Cgjh ANDhji ORlraj ANDghk ANDkml0 RSfemn01 ANDfnq1 ANDemr0 ANDnkrr1 FORKqola FORKrpua" \
  "ur ua lr la rr ra"

versis_compose 7 DME-true \
  "MEurlrab ANDaoc ANDpbd Ccie Cdif ORcdg Cgjh ANDhji ORlraj ANDghk ANDkml1 RSfemn10 ANDfnq0 ANDemr1 ANDnkrr0 FORKqola FORKrpua" \
  "ur ua lr la rr ra"

# -----------------------------------------------

outline ""
outline " =============================="
outline " CREATE ABSTRACTED PROCESSES"
outline " =============================="
outline ""

pa_copy_process DME-false ABS-DME-false-ua NULL "la rr" "tau tau"
pa_copy_process DME-false ABS-DME-false-la NULL "ua rr" "tau tau"
pa_copy_process DME-false ABS-DME-false-rr NULL "ua la" "tau tau"

pa_copy_process DME-true ABS-DME-true-ua NULL "la rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-la NULL "ua rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-rr NULL "ua la" "tau tau"

versis_trace_minimization 0 ABS-DME-false-ua
versis_trace_minimization 0 ABS-DME-false-la
versis_trace_minimization 0 ABS-DME-false-rr

versis_trace_minimization 0 ABS-DME-true-ua
versis_trace_minimization 0 ABS-DME-true-la
versis_trace_minimization 0 ABS-DME-true-rr

pa_copy_process TRACE_ABS-DME-false-ua DME-false-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-false-la DME-false-la NULL "" ""
pa_copy_process TRACE_ABS-DME-false-rr DME-false-rr NULL "" ""

pa_copy_process TRACE_ABS-DME-true-ua DME-true-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-true-la DME-true-la NULL "" ""
pa_copy_process TRACE_ABS-DME-true-rr DME-true-rr NULL "" ""

# -----------------------------------------------

outline ""
outline " ======================"
outline " INFO ABOUT PROCESSES"
outline " ======================"
outline ""

outline "DME-false has [pa_state_number DME-false] states."
outline "DME-false-ua has [pa_state_number DME-false-ua] states."
outline "DME-false-la has [pa_state_number DME-false-la] states."
outline "DME-false-rr has [pa_state_number DME-false-rr] states."
outline "DME-true-ua has [pa_state_number DME-true-ua] states."
outline "DME-true-la has [pa_state_number DME-true-la] states."
outline "DME-true-rr has [pa_state_number DME-true-rr] states."
outline ""
outline "DME-true has [pa_transition_number DME-true] transitions."
outline "DME-false-ua has [pa_transition_number DME-false-ua] transitions."
outline "DME-false-la has [pa_transition_number DME-false-la] transitions."
outline "DME-false-rr has [pa_transition_number DME-false-rr] transitions."
outline "DME-true-ua has [pa_transition_number DME-true-ua] transitions."
outline "DME-true-la has [pa_transition_number DME-true-la] transitions."
outline "DME-true-rr has [pa_transition_number DME-true-rr] transitions."

# -----------------------------------------------

outline ""
outline " ===================="
outline " CHECKING PROPERTIES"
outline " ===================="
outline ""

mc_check_actl 0 DME-false-ua "dme-cell-properties.actl"
mc_check_actl 0 DME-false-la "dme-cell-properties.actl"
mc_check_actl 0 DME-false-rr "dme-cell-properties.actl"

mc_check_actl 0 DME-true-ua "dme-cell-properties.actl"
mc_check_actl 0 DME-true-la "dme-cell-properties.actl"
mc_check_actl 0 DME-true-rr "dme-cell-properties.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line UA"
outline " ==========================================="
outline ""

mc_check_actl 0 DME-false-ua "dme-cell-static.actl"
mc_check_actl 0 DME-false-ua "dme-cell-dynamic.actl"
mc_check_actl 0 DME-false-ua "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line LA"
outline " ==========================================="
outline ""

mc_check_actl 0 DME-false-la "dme-cell-static.actl"
mc_check_actl 0 DME-false-la "dme-cell-dynamic.actl"
mc_check_actl 0 DME-false-la "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line RR"
outline " ==========================================="
outline ""

mc_check_actl 0 DME-false-rr "dme-cell-static.actl"
mc_check_actl 0 DME-false-rr "dme-cell-dynamic.actl"
mc_check_actl 0 DME-false-rr "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line UA"
outline " ==========================================="
outline ""

mc_check_actl 0 DME-true-ua "dme-cell-static.actl"
mc_check_actl 0 DME-true-ua "dme-cell-dynamic.actl"
mc_check_actl 0 DME-true-ua "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line LA"
outline " ==========================================="
outline ""

mc_check_actl 0 DME-true-la "dme-cell-static.actl"
mc_check_actl 0 DME-true-la "dme-cell-dynamic.actl"
mc_check_actl 0 DME-true-la "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line RR"
outline " ==========================================="
outline ""

mc_check_actl 0 DME-true-rr "dme-cell-static.actl"
mc_check_actl 0 DME-true-rr "dme-cell-dynamic.actl"
mc_check_actl 0 DME-true-rr "dme-cell-steady.actl"
