# /* Robert Meolic, 1. 12. 2002 */
# /* Primer za hazarde pri asinhronih vezjih */

set model "rejective"
source init.tcl

# STATIC

pa_copy_process or2abc00-$model ORabc NULL "a b c" "a b c"
pa_copy_process or2abc01-$model ORcfx NULL "a b c" "c f x"
pa_copy_process and2abc11-$model ANDdef NULL "a b c" "d e f"
pa_copy_process inv1ab0-$model INVad NULL "a b" "a d"
pa_copy_process inv1ab0-$model INVbe NULL "a b" "b e"

# DYNAMIC

pa_copy_process inv1ab0-$model INVac NULL "a b" "a c"
pa_copy_process inv1ab0-$model INVae NULL "a b" "a e"
pa_copy_process or2abc01-$model ORdef NULL "a b c" "d e f"
pa_copy_process and2abc00-$model ANDabd NULL "a b c" "a b d"
pa_copy_process and2abc11-$model ANDcfx NULL "a b c" "c f x"

# TRANSIENT

pa_copy_process inv1ab0-$model INVxa NULL "a b" "x a"
pa_copy_process and2abc10-$model ANDay1z NULL "a b c" "a y1 z"
pa_copy_process or2abc00-$model ORxy2y NULL "a b c" "x y2 y"
pa_copy_process fork1abcd0-$model FORKyy1y2Y NULL "a b c d" "y y1 y2 Y"

# STEADY

pa_copy_process and2abc10-$model ANDay2b NULL "a b c" "a y2 b"
pa_copy_process or2abc00-$model ORby1y1 NULL "a b c" "b y1 y1"
pa_copy_process or2abc00-$model ORxy2y2 NULL "a b c" "x y2 y2"
pa_copy_process fork1abc0-$model FORKy1y1Y1 NULL "a b c" "y1 y1 Y1"
pa_copy_process fork1abc0-$model FORKy2y2Y2 NULL "a b c" "y2 y2 Y2"

outline ""
outline " ==========================="
outline " COMPOSITION OF PROCESSES"
outline " ==========================="
outline ""

  versis_compose 7 STATIC \
    "ORabc ORcfx ANDdef INVad INVbe" \
    "a b x"

  versis_compose 7 DYNAMIC \
    "INVac INVae ANDabd ORdef ANDcfx" \
    "a b x"

  versis_compose 7 TRANSIENT \
    "INVxa ANDay1z ORxy2y FORKyy1y2Y" \
    "x z"

  versis_compose 7 STEADY \
    "INVxa ANDay2b ORby1y1 ORxy2y2 FORKy1y1Y1 FORKy2y2Y2" \
    "x Y1 Y2"

  versis_compose 7 STEADY1 \
    "INVxa ANDay2b ORby1y1 ORxy2y2 FORKy1y1Y1 FORKy2y2Y2" \
    "x Y1"

  versis_compose 7 STEADY2 \
    "INVxa ANDay2b ORby1y1 ORxy2y2 FORKy1y1Y1 FORKy2y2Y2" \
    "x Y2"

outline ""
outline " ======================"
outline " LOOKING FOR HAZARDS"
outline " ======================"
outline ""

mc_check_actl 0 STATIC "hazard-static.actl"
mc_check_actl 0 STATIC "hazard-dynamic.actl"
mc_check_actl 0 STATIC "hazard-steady.actl"

mc_check_actl 0 DYNAMIC "hazard-static.actl"
mc_check_actl 0 DYNAMIC "hazard-dynamic.actl"
mc_check_actl 0 DYNAMIC "hazard-steady.actl"

mc_check_actl 0 TRANSIENT "hazard-static.actl"
mc_check_actl 0 TRANSIENT "hazard-dynamic.actl"
mc_check_actl 0 TRANSIENT "hazard-steady.actl"

mc_check_actl 0 STEADY1 "hazard-static.actl"
mc_check_actl 0 STEADY1 "hazard-dynamic.actl"
mc_check_actl 0 STEADY1 "hazard-steady.actl"

mc_check_actl 0 STEADY2 "hazard-static.actl"
mc_check_actl 0 STEADY2 "hazard-dynamic.actl"
mc_check_actl 0 STEADY2 "hazard-steady.actl"
