#include <bdd.h>
#include <pa.h>
#include <versis.h>
#include <mc.h>

int main()
{
  Bdd_Boolean r;

  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Model Checking package\n");
  /* *********************************************************************** */

  Mc_InitPkg();
 
  /* *********************************************************************** */
  printf("pa_read_process <data/brp/brp.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/brp/brp.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort sortBRP\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortBRP");

  /* *********************************************************************** */
  printf("pa_encode_process 5 <sender receiver channelK channelL timers>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("sender");
  Pa_EncodeProcess("receiver");
  Pa_EncodeProcess("channelK");
  Pa_EncodeProcess("channelL");
  Pa_EncodeProcess("timers");

  /* *********************************************************************** */
  printf("%s\n\t%s\n\t%s\n",
      "versis_compose 1 BRP",
      "5 <sender receiver channelK channelL timers>",
      "8 <REQ SOK SNOK SDK RFST RINC ROK RNOK>");
  /* *********************************************************************** */

  Versis_Compose("BRP",1,5,"sender receiver channelK channelL timers",
                         8,"REQ SOK SNOK SDK RFST RINC ROK RNOK");

  /* *********************************************************************** */
  printf("pa_encode_process 3 <BRP_trace BRP_weak BRP_test>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("BRP_trace");
  Pa_EncodeProcess("BRP_weak");
  Pa_EncodeProcess("BRP_test");

  /* *********************************************************************** */
  printf("versis_weak_equivalence 1 BRP 0 BRP_weak\n");
  /* *********************************************************************** */

  r = Versis_Equivalence(1,1,"BRP",0,"BRP_weak");
  if (r) printf("TRUE\n"); else printf("FALSE\n");

  /* *********************************************************************** */
  printf("versis_testing_equivalence 1 BRP 0 BRP_test\n");
  /* *********************************************************************** */

  Versis_Equivalence(2,1,"BRP",0,"BRP_test");
  if (r) printf("TRUE\n"); else printf("FALSE\n");

  /* *********************************************************************** */
  printf("mc_check_actl 1 BRP <data/brp/brp.actl>\n");
  /* *********************************************************************** */

  Mc_CheckACTL(1,"BRP","../../data/brp/brp.actl",MC_SIMPLE);

  return(1);
}
