#include <bdd.h>
#include <pa.h>
#include <versis.h>
#include <mc.h>

int main()
{
  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Model Checking package\n");
  /* *********************************************************************** */

  Mc_InitPkg();
 
  /* *********************************************************************** */
  printf("pa_read_process <data/euro2000/euro2000.sort>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/euro2000/euro2000.sort");

  /* *********************************************************************** */
  printf("pa_read_process <data/euro2000/euro2000si.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/euro2000/euro2000si.dat");

  /* *********************************************************************** */
  printf("pa_read_process <data/euro2000/euro2000yu.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/euro2000/euro2000yu.dat");

  /* *********************************************************************** */
  printf("pa_read_process <data/euro2000/euro2000es.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/euro2000/euro2000es.dat");

  /* *********************************************************************** */
  printf("pa_read_process <data/euro2000/euro2000no.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/euro2000/euro2000no.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort sortEuro\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortEuro");

  /* *********************************************************************** */
  printf("pa_encode_process 4 <si yu es no>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("si");
  Pa_EncodeProcess("yu");
  Pa_EncodeProcess("es");
  Pa_EncodeProcess("no");

  /* *********************************************************************** */
  printf("%s\n\t%s\n\t%s\n",
      "versis_compose 1 euro",
      "4 <si yu es no>",
      "64 <...>");
  /* *********************************************************************** */

  Versis_Compose("euro",1,4,"si yu es no",64,
                 strdup(
                     "si1 si2 si3 si4 yu1 yu2 yu3 yu4 \
                     es1 es2 es3 es4 no1 no2 no3 no4 \
                     siwin siequal silose yuwin yuequal yulose \
                     eswin esequal eslose nowin noequal nolose \
                     si0points si1points si2points si3points si4points \
                     si5points si6points si7points si9points \
                     yu0points yu1points yu2points yu3points yu4points \
                     yu5points yu6points yu7points yu9points \
                     es0points es1points es2points es3points es4points \
                     es5points es6points es7points es9points \
                     no0points no1points no2points no3points no4points \
                     no5points no6points no7points no9points")
                );

  /* *********************************************************************** */
  printf("mc_check_actl 1 euro <data/euro2000/euro2000.actl>\n");
  /* *********************************************************************** */

  Mc_CheckACTL(1, "euro", "../../data/euro2000/euro2000.actl",MC_SIMPLE);

  return(1);
}
