#include <bdd.h>
#include <pa.h>
#include <versis.h>

int main()
{
  Bdd_Boolean r;

  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();

  /* *********************************************************************** */
  printf("pa_read_process <data/scheduler/scheduler4.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/scheduler/scheduler4.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort sortSCH4\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortSCH4");

  /* *********************************************************************** */
  printf("pa_encode_process 5 <starter S1 S2 S3 S4>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("starter");
  Pa_EncodeProcess("S1");
  Pa_EncodeProcess("S2");
  Pa_EncodeProcess("S3");
  Pa_EncodeProcess("S4");

  /* *********************************************************************** */
  printf("pa_encode_process 1 <SCH4>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("SCH4");

  /* *********************************************************************** */
  printf("%s\n\t%s\n\t%s\n",
      "versis_compose 1 scheduler",
      "5 <starter S1 S2 S3 S4>",
      "4 <a1 a2 a3 a4>");
  /* *********************************************************************** */

  Versis_Compose("scheduler",1,5,"starter S1 S2 S3 S4",
                               4,"a1 a2 a3 a4");

  /* *********************************************************************** */
  printf("versis_weak_equivalence 1 scheduler 0 SCH4\n");
  /* *********************************************************************** */

  Versis_Equivalence(1,1,"scheduler",0,"SCH4");
  if (r) printf("TRUE\n"); else printf("FALSE\n");

  return(1);
}
