#!/bin/sh
# the next line executes the program\
exec wish "$0" "$@"

# MAYBE YOU MUST USE ONE OF THE FOLLOWING LINES
# exec /usr/local/bin/wish "$0" "$@"
# exec /home/meolic/ActiveTcl/bin/wish "$0" "$@"

# $Revision: 2.3 $
# $Date: 2004/08/02 15:19:59 $

lappend auto_path "../../bwidget"

global VERSION
global PROMPT
global TITLE
global ICONNAME
global BINDIR

# --------------
# identification
# --------------

set VERSION "2nd Edition"
set PROMPT "EST> "
set TITLE "EST, $VERSION" 
set ICONNAME "EST"

# ------------
# OS
# ------------

set OS $tcl_platform(platform)

# ------------
# folder 
# ------------

cd [file dirname [info script]]
set BINDIR [pwd]

# ####################################################################
# Start My Interface Tcl/Tk GUI
# ####################################################################

source $BINDIR/mi.tcl

# ####################################################################
# My Interface package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/mi.so}
if {$OS == "windows"} {load $BINDIR/mi.dll}
mi_initPkg

source $BINDIR/miDialog.tcl

# ####################################################################
# Say hello
# ####################################################################

outline "This is Efficient Symbolic Tools, $VERSION."
outline "This program is free software, type license for details."
outline ""

outline "Running on $tcl_platform(machine) ($tcl_platform(os), $tcl_platform(osVersion)) with tcl $tcl_patchLevel and tk $tk_patchLevel." 
outline ""

# ####################################################################
# BDD package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/bdd.so}
if {$OS == "windows"} {load $BINDIR/bdd.dll}
bdd_initPkg

source $BINDIR/bddDialog.tcl

# ####################################################################
# Process algebra package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/pa.so}
if {$OS == "windows"} {load $BINDIR/pa.dll}
pa_initPkg

source $BINDIR/paDialog.tcl

# ####################################################################
# Versis package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/versis.so}
if {$OS == "windows"} {load $BINDIR/versis.dll}
versis_initPkg

source $BINDIR/versisDialog.tcl

# ####################################################################
# Model checking package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/mc.so}
if {$OS == "windows"} {load $BINDIR/mc.dll}
mc_initPkg

source $BINDIR/mcDialog.tcl

# ####################################################################
# Change to the default folder
# ####################################################################

cd $BINDIR/../data
outline ""

