global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.mc \
         .menuFrame.mc.menu \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.mc

menubutton .menuFrame.mc -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.mc.menu -pady 1 -text "Model checking"
pack .menuFrame.mc -side left
menu .menuFrame.mc.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.mc.menu add command  -command menu_mc_checkACTL -label "mc_check_actl"
.menuFrame.mc.menu add separator 
.menuFrame.mc.menu add check -label "Generate diagnostic" -variable diagnostic
.menuFrame.mc.menu add check -label "Generate automaton" -variable automaton
.menuFrame.mc.menu add check -label "Minimize automaton" -variable minimize
.menuFrame.mc.menu add check -label "Explain result" -variable explain
.menuFrame.mc.menu add check -label "Trace complete paths" -variable tracepath
.menuFrame.mc.menu add separator 
.menuFrame.mc.menu add command  -command mc_about -label "mc_about"

proc mc_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        mc_aboutPkg
        set f [open "$BINDIR/mc.about" r]
	
	while {[gets $f line] >= 0} {
          out "\# "
	  outline $line
	}	
        outline "\#\#\# "
	close $f
}

proc menu_mc_checkACTL {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
        global diagnostic
        global automaton
        global explain
        global minimize
        global tracepath
	
	set NAME "mc_check_actl"
	set SYNOPSIS "ACTL model checking."
	set SYNTAX "ptype%d pname%s fname%s param%d"
	set EXAMPLE "mc_check_actl 0 P safety.actl simple"
	set EXPLANATION "Check ACTL formulae in file safety.actl on process P"
        set BROWSE [list \
          {name "Select process/composition" proccomp} \
	  {file "Select file with ACTL formulae" {{{ACTL formulae} {.actl}}}} \
          {optional "Parameter (optional)" 60} \
        ]

	set CMD $NAME
	set CMDEND ""

        set PARAM ""
        if {$diagnostic == 1} {set PARAM "$PARAM | \$mc_diagnostic"}
        if {$automaton == 1} {set PARAM "$PARAM | \$mc_automaton"}
        if {$minimize == 1} {set PARAM "$PARAM | \$mc_minimize"}
        if {$explain == 1} {set PARAM "$PARAM | \$mc_explain"}
        if {$tracepath == 1} {set PARAM "$PARAM | \$mc_tracepath"}

        if {$PARAM != ""} {set PARAM "[string range $PARAM 2 [string length $PARAM]]"}
        if {$PARAM != ""} {set PARAM "\[expr $PARAM\]"}
	
       	commonDialog
}
