/**CFile*******************************************************************
  PackageName [mc]
  FileName    [mcParser.l]
  Author      [Robert Meolic (meolic@uni-mb.si)]

  Revision    [$Revision: 2.9 $]
  Date        [$Date: 2005/08/03 07:09:59 $]
  Synopsis    [Package 'mc' provides tools for ACTL model checking]
  Description []
  SeeAlso     [mc.h, mcInt.h]
  Copyright   [Copyright (C) 2000-2003 Robert Meolic
               This program is free software; you can redistribute it
               and/or modify it under the terms of the GNU General Public
               License (version 2) as published by the Free Software
               Foundation.

               This program is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 59 Temple Place, Suite 330,
               Boston, MA  02111-1307 USA.]
  ************************************************************************/

ACTION    	[-_A-Za-z0-9][-_A-Za-z0-9]*[?!]
VALTRUE         true|True|TRUE
VALFALSE        false|False|FALSE
NOT             not|Not|NOT
AND             and|And|AND
OR              or|Or|OR
EQV             eqv|Eqv|EQV
IMPL            impl|Impl|IMPL
TAU             tau|tAu|taU|tAU|Tau|TAu|TaU|TAU
EPSILON         eps|Eps|EPS|epsilon|Epsilon|EPSILON
OUTLINE 	#.*

%%
  int ch, inComm;

"/*"            {
                    for (inComm=1; inComm; ) {
                      switch (ch=input()) {
                        case '\n' : break;
			case '*'  : if (( ch=input()) == '/') {
                                      inComm=0;
			            } else {
                                      unput(ch);
                                    }
				    break;
                      }
                    }
                }	

[ ]		{/* preskok praznih mest */}

[\t\n\r]	{/* preskok praznega prostora */}

"'"	        {/* qoutes are ignored */}

"\""	        {/* qoutes are ignored */}

E		{return E;}
A		{return A;}
U		{return UNTIL;}
EX		{return EX;}
AX		{return AX;}
EF		{return EF;}
AF		{return AF;}
EG		{return EG;}
AG		{return AG;}

EE		{return EE;}
AA		{return AA;}
W		{return UNLESS;}
UU		{return UNLESS;}
EEX		{return EEX;}
AAX		{return AAX;}
EEF		{return EEF;}
AAF		{return AAF;}
EEG		{return EEG;}
AAG		{return AAG;}

"~"		{return NOT;}
"*"		{return AND;}
"&"		{return AND;}
"+"		{return OR;}
"|"		{return OR;}
"<->"		{return EQV;}
"->"		{return IMPL;}

{NOT}		{return NOT;}
{AND}		{return AND;}
{OR}		{return OR;}
{EQV}		{return EQV;}
{IMPL}		{return IMPL;}

"("	        {return yytext[0];}
")"	        {return yytext[0];}
"{"	        {return yytext[0];}
"}"		{return yytext[0];}
"["		{return yytext[0];}
"]"		{return yytext[0];}
"<"		{return yytext[0];}
">"		{return yytext[0];}
";"		{return yytext[0];}

{ACTION}	{
                 yylval.name = strdup(yytext);
                 return ACTION;
                }

{VALTRUE}       {
                 yylval.name = strdup("true");
                 return VALTRUE;
                }

{VALFALSE}      {
                 yylval.name = strdup("false");
                 return VALFALSE;
                }

{TAU}	        {
                 yylval.name = strdup("TAU");
                 return TAU;
                }

{EPSILON}	{
                 yylval.name = strdup("EPSILON");
                 return EPSILON;
                }

{OUTLINE}	{
                 yylval.name = strdup(yytext);
                 return OUTLINE;
                }

.               {
                 yylval.name = strdup(yytext);
                 return UNKNOWN;
                }
%%
