/**CFile*******************************************************************
  PackageName [pa]
  FileName    [paInt.h]
  Authors     [Robert Meolic (meolic@uni-mb.si)]

  Revision    [$Revision: 2.2 $]
  Date        [$Date: 2004/07/22 14:32:24 $]
  Synopsis    [Package 'pa' implements process algebra similar to Milner's
               CCS and Hoare's CSP.]
  Description [The file paInt.h contains declaration of internal
               data structures neded for implementation of
               process algebra.]
  SeeAlso     [pa.h, paMain.c]
  Copyright   [Copyright (C) 2000-2004 Robert Meolic
               This program is free software; you can redistribute it
               and/or modify it under the terms of the GNU General Public
               License (version 2) as published by the Free Software
               Foundation.

               This program is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 59 Temple Place, Suite 330,
               Boston, MA  02111-1307 USA.]
  ************************************************************************/

#ifndef _PAINT
#define _PAINT

#ifndef TCLOUT
#  define Mi_Out printf
   char outthread;
   int outflag;
   char *out;
#else
#  include <mi.h>
#  define printf Mi_Printf
#endif

#include "pa.h"

/*-----------------------------------------------------------------------*/
/* Constant declarations                                                 */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Structure declarations                                                */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Variable declarations                                                 */
/*-----------------------------------------------------------------------*/

/**AutomaticStart*********************************************************/

/*-----------------------------------------------------------------------*/
/* Function prototypes                                                   */
/*-----------------------------------------------------------------------*/

extern void Composition2ProcessR(Pa_Composition *comp, Bdd_Edge F,
                         Bdd_Boolean mark, int *decodingTableR,int procnum);

extern void Composition2ProcessRAS(Pa_Composition *comp, Bdd_Edge F,
                         Bdd_Boolean mark, int minA, int maxA,
                         int *decodingTableR, int *decodingTableS,
                         int procnum);

/**AutomaticEnd***********************************************************/

#endif  /* _PAINT */
