/**CFile*******************************************************************
  PackageName [pa]
  FileName    [paParser.l]
  Authors     [Robert Meolic (meolic@uni-mb.si)]

  Revision    [$Revision: 2.6 $]
  Date        [$Date: 2004/12/30 13:44:37 $]
  Synopsis    [Package 'pa' implements process algebra similar to Milner's
               CCS and Hoare's CSP.]
  Description []
  SeeAlso     [pa.h, paInt.h]
  Copyright   [Copyright (C) 2000-2003 Robert Meolic
               This program is free software; you can redistribute it
               and/or modify it under the terms of the GNU General Public
               License (version 2) as published by the Free Software
               Foundation.

               This program is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 59 Temple Place, Suite 330,
               Boston, MA  02111-1307 USA.]
  ************************************************************************/

PROCESS         process|Process|PROCESS
SORT            sort|Sort|SORT
TRANSITIONS     transitions|Transitions|TRANSITIONS
INITIAL_STATE	("Initial"[ \t]*"state")|("initial"([ \t]*)"state")|("INITIAL"[ \t]*"STATE")
FINAL_STATES	("Final"[ \t]*"states")|("final"([ \t]*)"states")|("FINAL"[ \t]*"STATES")

NAME            [-_A-Za-z0-9][-_A-Za-z0-9]*
ACTION          {NAME}[?!]|"tau"|"Tau"|"TAU"

OUTLINE 	#.*

%%
  int ch, inComm;

"/*"              { for(inComm=1; inComm; )
                    { switch(ch=input())
 			{ case '\n' : break;
			  case '*'  : if (( ch=input()) == '/')
					inComm=0;
				      else  unput(ch);
				break;
                        }
                    }
                  }	

[ ]	          {/* preskok praznih mest */}

[\t\n\r]       	  {/* preskok praznega prostora */}

"'"	          {/* qoutes are ignored */}

"\""	          {/* qoutes are ignored */}

{INITIAL_STATE}	  {return INITIAL_STATE;}

{FINAL_STATES}	  {return FINAL_STATES;}

{PROCESS}         {return PROCESS;}

{SORT}            {return SORT;}

{TRANSITIONS}     {return TRANSITIONS;}

GATES             {return GATES;}

ACTIONS           {return ACTIONS;}

{ACTION}	  {
                   yylval.word = strdup(yytext);
                   return ACTION;
                  }

{NAME}		  {
                   yylval.word = strdup(yytext);
                   return NAME;
                  }

","	          {return yytext[0];}
"."	          {return yytext[0];}
"+"	          {return yytext[0];}
"="	          {return yytext[0];}

{OUTLINE}	  {
                   yylval.word = strdup(yytext);
                   return OUTLINE;
                  }

.                 {
                   return UNKNOWN;
                  }
%%
