/**CFile*******************************************************************
  PackageName [versis]
  FileName    [versisCCS.l]
  Authors     [Robert Meolic (meolic@uni-mb.si),
               Mirjam Sepesy Maucec (mirjam.sepesy@uni-mb.si),
               Tatjana Kapus (kapus@uni-mb.si)]

  Revision    [$Revision: 2.4 $]
  Date        [$Date: 2004/04/09 14:21:17 $]
  Synopsis    [Package 'versis' provides tools for formal verification
               of concurrent systems]
  Description [The file versisCCS.l contains parser for CCS]
  SeeAlso     [versis.h, versisInt.h]
  Copyright   [Copyright (C) 2000-2003 Robert Meolic
               This program is free software; you can redistribute it
               and/or modify it under the terms of the GNU General Public
               License (version 2) as published by the Free Software
               Foundation.

               This program is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 59 Temple Place, Suite 330,
               Boston, MA  02111-1307 USA.]
  ************************************************************************/

NET             net|Net|NET
TAU             tau|Tau|TAU
NAME            [-_A-Za-z0-9][-_A-Za-z0-9]*
ACTION          {NAME}[?!]|[?!]{NAME}

OUTLINE 	#.*
COMMENT         --.*

%%
  int ch, inComm;

"/*"              { for(inComm=1; inComm; )
                    { switch(ch=input())
 			{ case '\n' : break;
			  case '*'  : if (( ch=input()) == '/')
					inComm=0;
				      else  unput(ch);
				break;
                        }
                    }
                  }	

[ ]	          {/* preskok praznih mest */}

[\t\n\r]       	  {/* preskok praznega prostora */}

"'"	          {/* qoutes are ignored */}

"\""	          {/* qoutes are ignored */}

{NET}	          {return NET;}

{TAU}         	  {
                   yylval.word = strdup("TAU");
                   return ACTION;
                  }

{ACTION}	  {
                   yylval.word = strdup(yytext);
                   return ACTION;
                  }

{NAME}		  {
                   yylval.word = strdup(yytext);
                   return NAME;
                  }

"||"	          {return COMPOSE;}
"//"	          {return MULTICOMPOSE;}
"/"	          {return RENAME;}
"\\"	          {return RESTRICT;}

"."	          {return SEP;}
";"	          {return SEP;}

"="	          {return yytext[0];}
"("	          {return yytext[0];}
")"	          {return yytext[0];}
"+"	          {return yytext[0];}

","	          {return yytext[0];}
"["	          {return yytext[0];}
"]"	          {return yytext[0];}

{COMMENT}         {};

{OUTLINE}	  {
                   yylval.outline = strdup(yytext);
                   return OUTLINE;
                  }

.                 {
                   return UNKNOWN;
                  }
%%
