#!/bin/sh
# the next line executes the program\
exec wish "$0" "$@"

global TITLE
global PROMPT
global VERSION
global ICONNAME

global FONT
global BUTTONFONT
global MENUFONT
global BIGFONT
global BLACKFONT

global MENUITEMS
global MENUBUTTONITEMS

# if {$tcl_platform(osVersion) == "windows"} {
#   console show
# }

# puts $tcl_platform(platform)
# puts $tcl_platform(machine)
# puts $tcl_platform(os)
# puts $tcl_platform(osVersion)
# puts $tcl_patchLevel

if {![info exists TITLE]} {set TITLE "My Interface"}
if {![info exists PROMPT]} {set PROMPT "MI> "}
if {![info exists VERSION]} {set VERSION ""}
if {![info exists ICONNAME]} {set ICONNAME "My Interface"}
        
font create FONT -family Helvetica -size 14 -weight normal -slant roman
font create BUTTONFONT -family Helvetica -size 14 -weight bold -slant roman
font create MENUFONT -family Helvetica -size 13 -weight normal -slant roman
font create BIGFONT -family Helvetica -size 18 -weight normal -slant roman
font create BLACKFONT -family Helvetica -size 15 -weight bold -slant roman

set MENUITEMS ""
set MENUBUTTONITEMS ""

source ./mi-gui.tcl

# mi_initPkg is executed after gui construction
proc mi_initPkg { } {
  global PROMPT
  global INPUTLINE
  global HISTORY
  global HISTORYNUMBER
  global HISTORYCURRENT
  global MENU

  global MENUFG
  global MENUBG
  global INPUTFG
  global INPUTBG
  global OUTPUTFG
  global OUTPUTBG

  .input.t insert insert $PROMPT
  .input.t mark set limit insert
  .input.t mark gravity limit left

  set INPUTLINE ""
  set HISTORY {}
  set HISTORYNUMBER 0
  set HISTORYCURRENT 0

  set MENUBG #008080
  set MENUFG #ffffff
  set OUTPUTBG #408080
  set OUTPUTFG #ffffff
  set INPUTBG #008080
  set INPUTFG #ffffff

  refresh

  focus .input.t
}

# GNU GPL (version 2)
proc license {  } {
	outline "Copyright (C) 2000-2004 Robert Meolic"
	outline \
	"This program is free software; you can redistribute it and/or modify it under"
	outline \
	"the terms of the GNU General Public License (version 2) as published by the"
	outline \
	"Free Software Foundation."
	outline ""
	outline \
	"This program is distributed in the hope that it will be useful, but WITHOUT"
	outline \
	"ANY WARRANTY;  without even the implied warranty of MERCHANTABILITY"
	outline \
	"or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public"
	outline \
	"License for more details."
	outline ""
	outline \
	"You should have received a copy of the GNU General Public License along"
	outline \
	"with this program; if not, write to the Free Software Foundation, Inc.,"
	outline \
	"59 Temple Place, Suite 330, Boston, MA  02111-1307 USA."
	outline ""
}

proc xsource fileName {
        global mc_simple
        global mc_trace
        global mc_xtrace
        global mc_explain
        global mc_tracepath
        global mc_diagnostic
        global mc_automaton
        global mc_minimize
        global mc_tree

	set f [open "$fileName" r]
	set olddir [pwd]
	cd [file dirname "$fileName"]
	set inputLine ""
	while {[gets $f line] >= 0} {
	  set d [expr [string length $line] - 1]
	  if { $d >= 0 } {
	    if { [string index $line 0] != "#" } {
	      if {[string index $line $d] == "\\"} {
	        set inputLine \
	        "$inputLine [string trimright [string range $line 0 [expr $d - 1]]]"
	      } else {
	        set inputLine "$inputLine $line"
	        set inputLine [string trimleft $inputLine]
		if {[string range $inputLine 0 2] == "out"} {
		  eval $inputLine
		} else {
  	          outline $inputLine
		  scan [time {eval $inputLine} 1] "%d" answ
	          set answ [expr $answ / 1000]
	          outline "==> CPU: $answ miliseconds <=="
	          outline ""
		}
	        set inputLine ""
	      }
	    }
	  } 
	} 
	close $f
	cd "$olddir"
}
