global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.interface \
         .menuFrame.interface.menu \
       .menuFrame.help \
         .menuFrame.help.menu \
]  {lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.interface
lappend MENUBUTTONITEMS .menuFrame.help

menubutton .menuFrame.interface -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.interface.menu -pady 1 -text "Interface"
pack .menuFrame.interface -side left
menu .menuFrame.interface.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.interface.menu add command  -command menu_interface_source -label "source"
.menuFrame.interface.menu add command  -command menu_interface_xsource -label "xsource"
.menuFrame.interface.menu add separator 
.menuFrame.interface.menu add command  -command menu_interface_printLog -label "Print Log"
.menuFrame.interface.menu add command  -command menu_interface_printSelection -label "Print Selection"
.menuFrame.interface.menu add separator 
.menuFrame.interface.menu add command  -command menu_interface_fonts -label "Fonts..."
.menuFrame.interface.menu add command  -command menu_interface_colors -label "Colors..."
.menuFrame.interface.menu add separator 
.menuFrame.interface.menu add command  -command mi_about -label "mi_about"
.menuFrame.interface.menu add separator 
.menuFrame.interface.menu add command  -command exit -label "Exit"

menubutton .menuFrame.help -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.help.menu -pady 1 -text "Help"
pack .menuFrame.help -side right
menu .menuFrame.help.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.help.menu add command  -command license -label "license"

proc mi_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        mi_aboutPkg
        set f [open "$BINDIR/mi.about" r]
	
	while {[gets $f line] >= 0} {
          out "\# "
	  outline $line
	}	
        outline "\#\#\# "
	close $f
}

proc menu_interface_source {  } {
	global PROMPT
	global INPUTWINDOW
	
	set types {
	  {"Tcl Scripts" {.tcl}}
	  {"All files" *}
	}
	set filename [tk_getOpenFile -filetypes $types]
	if {$filename != ""} {
	  set l "cd \"[file dirname $filename]\"; source \"[file tail $filename]\"; cd \"[pwd]\""
	  $INPUTWINDOW insert insert "$l\n"
	  $INPUTWINDOW insert insert $PROMPT
	  $INPUTWINDOW see insert
	  $INPUTWINDOW mark set limit insert
	  evalCommand $l
	}
}

proc menu_interface_xsource {  } {
	global PROMPT
	global INPUTWINDOW
	
	set types {
	  {"Tcl Scripts" {.tcl}}
	  {"All files" *}
	}
	set filename [tk_getOpenFile -filetypes $types]
	if {$filename != ""} {
	  set l "xsource \"$filename\""
	  $INPUTWINDOW insert insert "$l\n"
	  $INPUTWINDOW insert insert $PROMPT
	  $INPUTWINDOW see insert
	  $INPUTWINDOW mark set limit insert
	  evalCommand $l
	}
}

proc menu_interface_printLog {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
	global CMD
	global CMDINSERT
	
	set NAME "print_log"
	set SYNOPSIS "Print text in output window."
	set SYNTAX "print_log"
	set EXAMPLE "print_log"
	set EXPLANATION "Print output window"
	
	set CMD "$NAME "
	set CMDINSERT ""
	
	commonDialog
	
}

proc menu_interface_printSelection {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
	global CMD
	global CMDINSERT
	
	set NAME "print_selection"
	set SYNOPSIS "Print selected text."
	set SYNTAX "print_selection"
	set EXAMPLE "print_selection"
	set EXPLANATION "Print currently selected text"
	
	set CMD "$NAME "
	set CMDINSERT ""
	
	commonDialog
}

source menu_interface_colors.tcl
source menu_interface_fonts.tcl
